# Design Atoms Framework Changelog


## [6.14.1] - 2021-08-05
### Changed
- Now, if the `skew` value is defined for text elements in InDesign templates, these elements will be imported with the `fauxItalic` style.

### Fixed
- Rendering spines and folding lines on proof images when `proofImageMockupEnabled` is `false`.


## [6.14.0] - 2021-07-30
### Fixed
- Some problems with rendering `BarcodeItem`.


## [6.13.0] - 2021-07-21
### Added
- The possibility to disable the rendering of glyphs missing in the defined font. To perform this, you can use the configuration parameter `NotFoundGlyphRemovalEnabled`.

### Changed
- Improved the rendering time of text elements containing glyphs that are not present in the specified font. You can specify fonts containing such glyphs, in `PreferredFallbackFonts` as follows: `"ArialMT;Menlo-Bold"`.

### Fixed
- Verifying license keys.
- Rendering indexed RGB graphics with indexed colors when `PdfRenderKeepOriginalColors` is enabled.


## [6.12.0] - 2021-06-29
### Added
- Support for remote images when defining mockups through URLs.
- `ProductHandler.GetBoundsData(Product)` to obtain coordinates of the rectangles bounding items on all product surfaces.
- New violation warning that appears for text elements that are rendered by the Classic text engine when the WYSIWYG (In-place) engine is enabled.


## [6.11.1] - 2021-06-22
### Changed
- Optimized processing of multiple requests. Large bitmaps are now processed separately from the main combined bitmap.

### Fixed
- Reading PostScript names of fonts used in InDesign templates.
- Reading locked layers from InDesign templates.


## [6.11.0] - 2021-06-07
### Added
- You can now refer to a specific page in an embedded PDF file when reading multipage IDML templates.

### Fixed
- Loading PSD templates when there were images with the same name.


## [6.10.0] - 2021-05-28
### Changed
- The `<RT>` marker can be used again to determine whether to apply the rich formatting to imported text items or not.

### Fixed
- Rendering text items.


## [6.9.11] - 2021-05-24
### Fixed
- Loading InDesign templates where bounds of PDF graphics did not match the bounds of its frame.


## [6.9.10] - 2021-05-20
### Added
- The `ForceLegacyTextRendering` parameter to render text with the Classic text engine.

### Fixed
- Loading InDesign templates that have set bleed and slug values.
- Deserialization of state files saved in version 4 and then rendered in version 5 or later.


## [6.9.8] - 2021-05-13
### Added
- Support for `Grayscale` image effect.


## [6.9.3] - 2021-04-22
### Added
- Support for images in texture containers when using the Asset Storage.


## [6.9.1] - 2021-04-19
### Added
- Support for fonts when rendering text from SVG files.

### Fixed
- Reading the region bounds from IDML files when `LegacyIdmlBleedParsingEnabled` is `true`.
- Positioning a file stream when converting product templates.
- Serialization of `ViolationSettings`.


## [6.9.0] - 2021-04-12
### Fixed
- Import of IDML files with flipped images.
- Deserialization of state files when they were saved earlier than version 5.5 and then opened in 5.5 or later.


## [6.8.0] - 2021-04-02
### Added
- Support for Intelligent Mail Barcode.
- Support for vertical alignment, auto size, and copyfitting in the WYSIWYG editor.

### Fixed
- Reading `PathTextItem` when the path is flipped.


## [6.7.0] - 2021-03-24
### Added
- You can now manage violation settings for a single item.
- Improved logic for checking the trim zone violation.


## [6.6.0] - 2021-03-17
### Changed
- Optimized performance of the VDP rendering.

### Fixed
- Processing text styles.

## [6.5.0] - 2021-03-11
### Added
- Support for anchor points in auto-layout groups.


## [6.4.0] - 2021-03-04
### Added
- Support for overprint: you can now import overprint-related properties from InDesign templates and output them to PDF files.

### Fixed
- Updating `ImageItem` that uses a Url as the image source when this Url does not support the HEAD method.


## [6.3.4] - 2021-02-19
### Fixed
- Rendering text with spot colors.
- Memory leaks when rendering hi-res files.


## [6.3.3] - 2021-02-15
### Fixed
- Some problems with loading products from templates.


## [6.3.2] - 2021-02-10
### Fixed
- Deserialization of `ImageItem`.


## [6.3.0] - 2021-01-21
### Added
- You can now load templates by using `TemplateParser.FromStream` and `TemplateParser.FromStreams`.

### Fixed
- Reading linked images from InDesign templates.
- `ShapeItem` serialization when a file with long path was not saved in the state file.


## [6.2.0] - 2020-12-30
### Changed
- Serialization of the `blendMode`.

### Fixed
- A problem when `IProductRenderer.RenderProof()` ignored the `ShowStubContent` option.


## [6.1.1] - 2020-12-16
### Fixed
- Reading the `DefaultFontPostScriptName` parameter.
- Invalidation of `ImageItem` that uses a URL as the `Source`.
- PDF boxes not set on the pages rendered from channel containers.


## [6.1.0] - 2020-12-07
### Added
- Support for `DataMatrix` barcodes.


## [6.0.4] - 2020-12-02
### Fixed
- Applying `VisualizationPermissions` to a `GroupItem`.


## [6.0.3] - 2020-11-26
### Fixed
- Removing the surrogate pair characters from text.


## [6.0.2] - 2020-11-20
### Fixed
- Obtaining bounds of shape items.


## [6.0.1] - 2020-11-12
### Changed
- Improved performance when generating preview images of products containing PDF graphics.
- When text items have several SPANs with the same styles, they are converted into one SPAN when processing styles.
- Font stream compression was moved to `IFontServiceExtended`.

### Fixed
- Reading in-string placeholders from InDesign templates.
- Reading group items from InDesign templates.
- Applying permissions to a group of layers.
- A problem when rotated text items could move in the viewer while editing text.


## [6.0.0] - 2020-11-02
### Added
- Support for `LayoutItem`.

### Removed
- The default PostScriptName `ArialMT`.


## [5.34.1] - 2020-10-22
### Changed
- Now, product templates can be completely loaded despite possible exceptions, which will only be logged.

### Fixed
- Rendering proof images when products contain a large number of items.
- Some problems with color management.


## [5.34.0] - 2020-10-06
### Removed
- Dependency on `System.Web.UI.WebControls.Unit`.

### Fixed
- Displaying safety lines in the `Viewer`.


## [5.33.0] - 2020-09-23
### Added
- `ArchedTextItem`.
- `Bleed` and `Slug` zones to the `PrintArea`.
- The possibility to select a color in the `Viewer`.
- The possibility to render proof images when using only max width or max height.

### Fixed
- Some problems with cloning items in the `Viewer`.
- Adding barcodes to the product.


## [5.32.3] - 2020-09-08
### Changed
- Now, the file access time will be updated in `FileStorage` when a product is loaded.


## [5.32.2] - 2020-09-02
### Fixed
- Import of barcode placeholders from InDesign templates.
- Resizing the rotated items.
- A problem when items with gradient fill, imported from InDesign templates, could appear shifted in the viewer and hi-res outputs.


## [5.32.1] - 2020-08-17
### Fixed
- Rendering the border of an image placeholder based on a shape layer.


## [5.31.0] - 2020-07-23
### Changed
- The object model has been separated from the DesignAtoms package. Now, you must additionally install **@aurigma/design-atoms-model** from npm and **Aurigma.DesignAtoms.Model** from NuGet. In your .ts code, replace imports `@aurigma/design-atoms/Model/<class>` with `@aurigma/design-atoms-model/<class>`.

### Fixed
- Reading the background layers from multipage InDesign templates.


## [5.30.2] - 2020-07-07
### Fixed
- Serialization and deserialization of state files that contain images.
- Rendering text that wraps around design elements.
- A problem when HTML tags were not escaped when rendering plain text elements.
- A problem when proof images were rendered with the default size despite the specified parameter `maxSize`.


## [5.30.0] - 2020-06-25
### Added
- The possibility to import vector graphics from SVG files as a `ClipartItem`. Unlike a `GroupItem`, you can't ungroup clipart or add elements to it. However, you can change the colors of several clipart elements in a single action.


## [5.28.1] - 2020-06-12
### Fixed
- Some problems with reading and manipulating grouped elements.


## [5.27.0] - 2020-05-27
### Fixed
- Reading rich formatted text from InDesign templates.
- A problem when hidden elements of PDF files embedded in InDesign templates were added to the object model.


## [5.26.0] - 2020-05-12
### Added
- `IConfiguration.IgnoreInDesignMissingLinks` to configure how to process missing images when reading InDesign templates. If `true`, creates an empty image placeholder instead of such images. If `false`, throws an exception.

### Fixed
- Some problems with reading group items from InDesign templates.
- Rendering text that was vertically scaled in InDesign.


## [5.25.0] - 2020-04-14
### Added
- The possibility to import grouped elements from InDesign and Photoshop templates as a `GroupItem`.
- Support for the `Format1bppIndexed` pixel format in InDesign templates.

### Fixed
- Unnecessary color conversion when applying the `Colorize` effect to TIFF images.


## [5.24.0] - 2020-04-01
### Fixed
- Reading rich formatted text on a curve from PSD templates.
- Importing bleed zones from IDML templates.


## [5.23.0] - 2020-03-26
### Added
- The possibility to disable ASP.NET Attribute Routing.

### Fixed
- A problem when the bounding rectangle of a `PathBoundedTextItem` changed after deleting its content.


## [5.21.0] - 2020-02-26
### Changed
- Updated the system requirements. Now, you need TypeScript 3.8.2 to use the Design Atoms Framework.


## [5.20.0] - 2020-02-19
### Fixed
- Reading the baseline shift defined for InDesign text items.
- A problem when channel containers were rendered on proof images with an offset relative to the `designLocation`.


## [5.19.3] - 2020-02-14
### Fixed
- Wrapping text around design items.


## [5.19.0] - 2020-02-04
### Added
- Support for the color overlay effect defined for image placeholders in Photoshop templates.

### Fixed
- A problem when bounded text was imported from IDML templates as `PathBoundedTextItem`.
- Rendering bounded text when its bottom line contains subscript characters that go out of the text frame.
- Reading the autoleading in InDesign text frames.


## [5.18.0] - 2020-01-21
### Fixed
- Handling the rotation grip on the canvas.
- Some problems with handling bounded text items on the canvas.
- A problem when the `BleedBox` defined in InDesign templates affected the content of image placeholders.


## [5.17.1] - 2019-12-30
### Changed
- Optimized rendering of print files in the PDF format.
- Optimized saving state files by using `StateFileSerializer`.

### Fixed
- Reading the `First Baseline` options of InDesign text frames.
- Rendering of folding lines and spines on proof images when mockups were enabled.
- A problem when folding lines and spines were applied to mockups instead of designs.


## [5.17.0] - 2019-12-26
### Fixed
- Rendering the cropped proof images when folding lines were defined for the product.


## [5.16.0] - 2019-12-13
### Fixed
- Loading InDesign templates with linked PDF graphics.
- Adjusting text on a curve when its font size reached the minimum value.


## [5.15.0] - 2019-12-05
### Fixed
- Importing EPS graphics embedded in compound frames of IDML templates.
- Some problems with loading multipage IDML templates with defined bleed zones.


## [5.14.2] - 2019-11-29
### Fixed
- Cloning vector masks.


## [5.14.0] - 2019-11-22
### Fixed
- A problem causing **color conversion** exception when loading some IDML templates.
- A problem when PDF graphics embedded into InDesign templates appeared distorted on the canvas.
- Redrawing text items in the `Viewer`.


## [5.13.0] - 2019-11-08
### Added
- Support for UPC-A, UPC-E, and Code 128 barcodes.
- To maintain the consistency in dependency injection, the following interfaces were added: `IBarcodeGenerator`, `IBarcodeService`, `ICanvasBuilder`, `IColorManagement`, `IFrameConfigHandler`, `IImageLoader`, `IMergeUtil`, `IProductHandler`, `IProductSerializer`, `IRemoteImageLoader`, `ITemplateParser`, `ITextRenderer`, `IUnsupportedGlyphService`, and `IWatermarkItemsBuilder`. These interfaces implement the same functionality as their derived classes, and these classes will be removed in the next major release.

### Fixed
- Loading state files created in Customer's Canvas 5.0.


## [5.12.1] - 2019-10-29
### Fixed
- A problem when incorrect names of spot colors appeared in PDF outputs.


## [5.12.0] - 2019-10-22
### Added
- Support for `Frame Fitting Options` in InDesign templates. Now, you can enable `Auto-Fit` and use the selected `Fitting` value as the [content resize mode](https://customerscanvas.com/help/designing/adobe/indesign/intro.html#images) of image placeholders.

### Fixed
- Reading the image size in templates created in InDesign CS4.
- Rendering XML Escape characters in plain text elements.	
- Rendering the ampersand (`&`) symbol in plain and rich formatted text when using the `All Caps` style.


## [5.11.0] - 2019-10-10
### Added
- Support for locked (`Item.Locked`) and visible (`Item.Visible`) attributes in InDesign templates.
- Support for `Drop Shadow` effect in InDesign templates.

### Fixed
- Loading IDML templates created in InDesign CS4.

## [5.10.0] - 2019-09-25
### Added
- Support for the `All caps` OpenType feature in IDML templates.

### Fixed
- Reading `Superscript` characters specified in point text in PSD templates.
- Reading linked graphics from IDML templates.


## [5.9.0] - 2019-09-13
### Fixed
- Loading IDML templates that contain some specific fonts.
- Color management when rendering shapes and text elements in IDML templates.
- Rendering design elements when applying the multiply blend mode and gradient fill in IDML templates.
- Rendering proof images when the product width significantly differs from the product height.


## [5.8.2] - 2019-09-02
### Fixed
- Background colors when rendering products by using `IProductRenderer.RenderHiRes`.


## [5.7.1] - 2019-08-26
### Fixed
- Color management when rendering PDF graphics with embedded color profiles.


## [5.7.0] - 2019-08-22
### Added
- Support for variable data printing in `IProductRenderer`. Now, you can pass a product-based template and a data set to render personalized proof images and high-resolution outputs.

### Fixed
- A problem with PDF page boxes when defining a print area on the front end.


## [5.6.0] - 2019-08-15
### Fixed
- Conversion of spot colors.
- Some problems with rendering PDF graphics embedded into InDesign templates.


## [5.4.0] - 2019-07-19
### Added
- The possibility to render Lab colors into PDF outputs.
- A new mode of the overflow strategy for bounded text elements. You can allow for expanding the original text area through the `overflowStrategy` property of text item config.
- The possibility to change colors of barcodes and barcode placeholders.

### Fixed
- Some problems causing **Index out of range** and **Unsupported pixel format** errors when loading specific IDML templates.


## [5.2.0] - 2019-06-25
### Added
- Support for blend modes and spot colors in InDesign templates.

### Released
- A new **Aurigma.DesignAtoms.x86** NuGet package that allows for using the Design Atoms Framework in the x86 environment.


## [5.1.1] - 2019-06-06
### Changed
- Now, when you use either `Evaluation` or `Developer` license key, watermarks appear on the canvas notifying you of the license expiration date.


## [5.1.0] - 2019-05-31
### Released
- SDK source code. You can now completely customize the on-premises version of Customer's Canvas 5.

### Changed
- Now, Customer's Canvas uses default names of InDesign elements (in angle brackets) as names for items.
- Now, when you specify the bleed area in InDesign, it will be used as the trim box in PDF outputs.

### Fixed
- A problem when after changing a license key, it was not applied.


## [5.0.1] - 2019-05-24
### Added
- Support for rich formatted text on a curve. You can enable a rich format by using the `<RT>` marker or various formatting for curved text.
- Support such OpenType Features as ligatures, uppercase, small caps, lowercase, superscript, and subscript. Now, you can use these features in PSD and IDML templates and render them both on the canvas and in hi-res outputs.
- Support for vector masks of text and image layers.
- The possibility to crop hi-res outputs to safety lines. You can specify how to crop them by using the `pdfBox` property in your definition of `safetyLines`.

### Fixed
- Using the `ColorFactory` in the Iframe API.


## [5.0.0] - 2019-04-25
### Released
- Initial version of the [official API](https://customerscanvas.com/dev/editors/iframe-api/howto/manipulating-items.html) to work with each element of a design loaded into the editor.
- A ready-to-use project with [code samples](https://customerscanvas.com/dev/editors/design-atoms-cs/sample-project.html) on GitHub.
